// -------------------------------------------------------------------------------
// 
// 		cwCu		֌WvOwb_t@C
// 
// 				Ver 3.22c
// 
// -------------------------------------------------------------------------------

#ifndef DX_MEMORY_H
#define DX_MEMORY_H

// CN[h ------------------------------------------------------------------
#include "DxCompileConfig.h"
#include "DxThread.h"
#include "DxHeap.h"

#ifdef WINDOWS_DESKTOP_OS
#include "Windows/DxMemoryWin.h"
#endif // WINDOWS_DESKTOP_OS

#ifdef __ANDROID__
#include "Android/DxMemoryAndroid.h"
#endif // __ANDROID__

#ifdef __APPLE__
    #include "TargetConditionals.h"
    #if TARGET_OS_IPHONE
		#include "iOS/DxMemoryiOS.h"
    #endif // TARGET_OS_IPHONE
#endif // __APPLE__




#ifndef DX_NON_NAMESPACE

namespace DxLib
{

#endif // DX_NON_NAMESPACE

// }N` --------------------------------------------------------------------

// mیn֐
#if !defined( BC_COMPILER ) || defined( _DEBUG )
	#define DXALLOCBASE( size, aligned )	DxAllocBase( (size), (aligned), __FILE__, __LINE__ )
	#define DXALLOC( size )					NS_DxAlloc( (size), __FILE__, __LINE__ )
	#define DXCALLOC( size )				NS_DxCalloc( (size), __FILE__, __LINE__ )
	#define DXREALLOC( mem, size )			NS_DxRealloc( (mem), (size), __FILE__, __LINE__ )
	#define DXFREE( mem )					NS_DxFree( (mem) )
#else
	#define DXALLOCBASE( size, aligned )	DxAllocBase( (size), (aligned), "", 0 )
	#define DXALLOC( size )					NS_DxAlloc( (size), "", 0 )
	#define DXCALLOC( size )				NS_DxCalloc( (size), "", 0 )
	#define DXREALLOC( mem, size )			NS_DxRealloc( (mem), (size), "", 0 )
	#define DXFREE( mem )					NS_DxFree( (mem) )
#endif



// \̒` --------------------------------------------------------------------

// ֌W̏\
struct MEMORYDATA
{
	size_t					AllocMemorySize ;					// mۂĂ郁̑
	int						AllocMemoryNum ;					// CuŊmۂ̐
	int						AllocMemoryPrintFlag ;				// mۂ鎞ɏo͂邩ǂ̃tO
	int						AllocMemorySizeOutFlag ;			// mۂsxɊmۃ̑ʂOɏo͂邩ǂ̃tO
	int						AllocMemoryErrorCheckFlag ;			// mۂsxɊmۃ̏񂪔jĂȂ`FbN邩ǂ̃tO
	size_t					AllocTrapSize ;						// 񋓑ΏۂɂmۃTCY

	int						InitializeFlag ;					// tO
	int						StartTime ;							// JEgJn
	HEAPINFO				SmallHeap ;							// TCỸmۗpq[v
	HEAPINFO				BigHeap ;							// 傫TCỸmۗpq[v

#if defined( DX_THREAD_SAFE ) || defined( DX_THREAD_SAFE_NETWORK_ONLY )
	int						InitMemoryAllocCriticalSection ;	// MemoryAllocCriticalSection ̏ςł邩ǂ̃tO
	DX_CRITICAL_SECTION		MemoryAllocCriticalSection ;		// mۏpNeBJZNV
#endif
} ;

// e[u-----------------------------------------------------------------------

// ϐ錾 --------------------------------------------------------------

// ֌W̏
extern MEMORYDATA MemData ;

// ֐vg^Cv錾-----------------------------------------------------------

extern	int			MemoryInitialize( void ) ;												// ̏s
extern	int			MemoryTerminate( void ) ;												// ̌ns
extern	int			MemoryProcess( void ) ;													// ̎I
extern	int			MemoryDrawAllocInfo( int x, int y, int Width, int Height ) ;			// ̊mۏ󋵂`悷

extern	void		MemoryDump( void *buffer, int size ) ;

extern	void *		DxAllocBase( size_t AllocSize, size_t Aligned, const char *File = NULL, int Line = -1, int NoMemoryDump = FALSE ) ;	// DxAlloc ̓p֐
extern	void *		DxReallocBase( void *Memory, size_t AllocSize, size_t Aligned, const char *File = NULL, int Line = -1 ) ;			// DxRealloc ̓p֐


// ˑ֐
extern	int			MemoryInitialize_PF( void ) ;								// ̏s֐̊ˑ
extern	int			MemoryTerminate_PF( void ) ;								// ̌ns֐̊ˑ
extern	int			MemoryProcess_PF( void ) ;									// ̎I̊ˑ

extern	int					 NormalMemory_AutoAlloc_CreateHeapCallback_PF(     int Param, void *Buffer, ALLOCMEM_SIZE_TYPE Size ) ;		// ˑ̈ʓIȃq[vp̃̈mۂ邽߂̃R[obN֐Q AutoAlloc_CreateHeapCallback
extern	void *				 NormalMemory_AutoAlloc_GetHeapAddressCallback_PF( int Param, void *Buffer ) ;			// ˑ̈ʓIȃq[vp̃̈mۂ邽߂̃R[obN֐Q AutoAlloc_GetHeapAddressCallback
extern	ALLOCMEM_SIZE_TYPE	 NormalMemory_AutoAlloc_GetHeapSizeCallback_PF(    int Param, void *Buffer ) ;			// ˑ̈ʓIȃq[vp̃̈mۂ邽߂̃R[obN֐Q AutoAlloc_GetHeapSizeCallback
extern	int					 NormalMemory_AutoAlloc_DeleteHeapCallback_PF(     int Param, void *Buffer ) ;			// ˑ̈ʓIȃq[vp̃̈mۂ邽߂̃R[obN֐Q AutoAlloc_DeleteHeapCallback

extern	int			DxDumpAlloc_PF( void ) ;									// mۂĂ郁񋓂֐̊ˑ

#ifndef DX_NON_NAMESPACE

}

#endif // DX_NON_NAMESPACE

#endif // DX_MEMORY_H
